<template>
  <Container class="h-full flex flex-col">
    <section class="flex items-center justify-between gap-2">
      <SectionHeader icon="mdi-tag-multiple">
        Услуги
      </SectionHeader>

      <v-scroll-y-transition>
        <v-btn
          v-if="[BookingStatus.BOOKED, BookingStatus.ACTIVE].includes(booking.status)"
          variant="tonal"
          class="text-amber-600 flex-initial"
          size="small"
          icon="mdi-pencil"
          @click="isEditShown = true"
        />
      </v-scroll-y-transition>
    </section>

    <section
      v-if="!booking.amenities.length"
      class="flex-auto mt-2"
    >
      <EmptyState
        class="bg-gray-100 py-6"
        embedded
      />
    </section>

    <v-list
      v-else
      lines="two"
    >
      <v-list-item
        v-for="(amenity, index) in booking.amenities"
        :key="amenity.id"
        class="[&_.v-list-item-title]:whitespace-normal"
        :class="{ 'bg-gray-100': index % 2 === 0 }"
      >
        <template #prepend>
          <v-icon icon="mdi-tag-outline" />
        </template>

        <template #title>
          <section class="flex items-center gap-2">
            <span class="text-gray-500">
              x{{ amenity.quantity }}
            </span>

            <span>{{ amenity.name }}</span>
          </section>
        </template>

        <template #subtitle>
          <ProfitDisplay
            mode="plain"
            :value="amenity.appliedProfit"
          />
        </template>
      </v-list-item>
    </v-list>
  </Container>

  <v-dialog
    v-model="isEditShown"
    persistent
  >
    <FloatingContainer>
      <FormHeader
        icon="mdi-pencil-outline"
        headline="Изменение услуг"
        subtitle="Прибыль от бронирования будет пересчитана"
      />

      <section class="pt-4">
        <FormRow label="Выберите услуги">
          <section class="min-w-full w-min">
            <AmenitiesSelection v-model="updatedAmenities" />
          </section>
        </FormRow>

        <FormRow spacing="large">
          <v-btn
            block
            rounded
            size="large"
            class="text-white font-bold bg-gradient-to-r from-teal-400 to-cyan-500"
            @click="onAmenitiesUpdate"
          >
            Изменить
          </v-btn>
        </FormRow>

        <FormRow>
          <v-btn
            block
            rounded
            size="small"
            variant="plain"
            :ripple="false"
            class="font-bold"
            @click="onAmenitiesUpdateCancel"
          >
            Отмена
          </v-btn>
        </FormRow>
      </section>
    </FloatingContainer>
  </v-dialog>
</template>

<script setup lang="ts">
import { ref, watch } from 'vue';

import { BookingStatus } from '@/declarations';
import AmenitiesSelection from '../create/AmenitiesSelection.vue';

import Container from '@/components/layout/Container.vue';
import ProfitDisplay from '@/components/content/ProfitDisplay.vue';
import EmptyState from '@/components/layout/EmptyState.vue';

import SectionHeader from '@/components/layout/SectionHeader.vue';
import FormHeader from '@/components/layout/FormHeader.vue';
import FormRow from '@/components/layout/FormRow.vue';
import FloatingContainer from '@/components/layout/FloatingContainer.vue';

const props = defineProps<{ booking: IVerboseBooking }>();
const emit = defineEmits(['update:amenities']);

const getAmenitiesClone = () => {
  return props.booking.amenities.map(amenity => ({ ...amenity }));
};

const isEditShown = ref(false);
const updatedAmenities = ref(getAmenitiesClone());

const onAmenitiesUpdate = () => {
  isEditShown.value = false;
  emit('update:amenities', updatedAmenities.value);
};

const onAmenitiesUpdateCancel = () => {
  isEditShown.value = false;
  updatedAmenities.value = getAmenitiesClone();
};

watch(isEditShown, () => {
  updatedAmenities.value = getAmenitiesClone();
});
</script>